import { jsx as _jsx } from "react/jsx-runtime";
import { createStellarIdenticon } from "../../helpers/createStellarIdenticon";
import { Icon } from "../../icons";
import "./styles.scss";
export var Avatar = function (_a) {
    var size = _a.size, publicAddress = _a.publicAddress, userName = _a.userName;
    var getInitials = function (userName) {
        var arr = userName.split(" ");
        if (arr.length >= 2) {
            return "".concat(arr[0].charAt(0)).concat(arr[1].charAt(0));
        }
        return userName.charAt(0);
    };
    var renderIcon = function () {
        if (publicAddress) {
            return (_jsx("img", { src: createStellarIdenticon(publicAddress).toDataURL(), alt: "Stellar address identicon" }));
        }
        if (userName) {
            return _jsx("div", { className: "Avatar__initials", children: getInitials(userName) });
        }
        return _jsx(Icon.User01, {});
    };
    return _jsx("div", { className: "Avatar Avatar--".concat(size), children: renderIcon() });
};
Avatar.displayName = "Avatar";
//# sourceMappingURL=index.js.map