import React from "react";
import "./styles.scss";
interface ModalComponent {
    Heading: React.FC<ModalHeadingProps>;
    Body: React.FC<ModalBodyProps>;
    Footer: React.FC<ModalFooterProps>;
}
export interface ModalHeadingProps {
    children: string | React.ReactNode;
}
export interface ModalBodyProps {
    children: React.ReactNode;
}
export interface ModalFooterProps {
    children: React.ReactNode;
    itemAlignment?: "right" | "stretch" | "stack";
}
export interface ModalProps {
    parentId?: string;
    visible: boolean;
    onClose: () => void;
    disableWindowScrollWhenOpened?: boolean;
    offsetTop?: string;
    alignToBottom?: boolean;
    children: React.ReactNode;
}
export declare const Modal: React.FC<ModalProps> & ModalComponent;
export {};
//# sourceMappingURL=index.d.ts.map